#pragma once
#include "stdafx.h"
#include <atlpath.h>
#include "shellapi.h"
#include "checkinexecution.h"

using namespace tipbase;
namespace tipupgrader
{
	class UpgraderUtil
	{
	public:
		UpgraderUtil():m_hMutex(NULL){}
		virtual ~UpgraderUtil() {}

		void GetTemporaryPath(TCHAR* path, int size)
		{
			GetTempPath(size, path);
			ATLPath::RemoveFileSpec(path);
		}
		BOOL IsRunningInTempPath() 
		{ 
			TCHAR filePath[MAX_PATH] = {0, };
			GetModuleFileName(NULL, filePath, MAX_PATH);
			ATLPath::RemoveFileSpec(filePath);

			TCHAR tempPath[MAX_PATH] ={0, };
			GetTemporaryPath(tempPath, MAX_PATH);

			return (_tcsicmp(filePath, tempPath) == 0);
		}

		void RunSelfInTempPath(LPCTSTR cmdParameter)
		{
			TCHAR filePath[MAX_PATH] = {0, };
			GetModuleFileName(NULL, filePath, MAX_PATH);

			TCHAR tempPath[MAX_PATH] ={0, };
			GetTemporaryPath(tempPath, MAX_PATH);
			CString tempFilePath = tempPath;
			

			TCHAR* fileName = ATLPath::FindFileName(filePath);
			tempFilePath += _T("\\");
			tempFilePath += fileName;

			//  ð ش.  ǰ ִٸ Write   ȵ
			Sleep(500);

			if (CopyFile(filePath, tempFilePath, FALSE))
			{
				// ׻ ŴнƮ  temp  ϵ Ѵ.
//				if (CheckInExecution::GetWindowVersion() == WindowVersion::win_VISTA)
//				{
					TCHAR srcManifest[MAX_PATH] = {0  };
					TCHAR dstManifest[MAX_PATH] = {0, };
					_tcscpy_s(srcManifest, MAX_PATH, filePath);
					ATLPath::RemoveFileSpec(srcManifest);
					_tcscpy_s(dstManifest, MAX_PATH, tempFilePath);
					ATLPath::RemoveFileSpec(dstManifest);
					ATLPath::Append(srcManifest, _T("Microsoft.VC90.CRT.manifest"));
					ATLPath::Append(dstManifest, _T("Microsoft.VC90.CRT.manifest"));
					CopyFile(srcManifest, dstManifest, FALSE);

					ATLPath::RemoveFileSpec(srcManifest);
					ATLPath::RemoveFileSpec(dstManifest);
					ATLPath::Append(srcManifest, _T("msvcp90.dll"));
					ATLPath::Append(dstManifest, _T("msvcp90.dll"));
					CopyFile(srcManifest, dstManifest, FALSE);

					ATLPath::RemoveFileSpec(srcManifest);
					ATLPath::RemoveFileSpec(dstManifest);
					ATLPath::Append(srcManifest, _T("msvcr90.dll"));
					ATLPath::Append(dstManifest, _T("msvcr90.dll"));
					CopyFile(srcManifest, dstManifest, FALSE);

#define AGREEMENT_CHANGE
#ifdef AGREEMENT_CHANGE
					ATLPath::RemoveFileSpec(srcManifest);
					ATLPath::RemoveFileSpec(dstManifest);
#ifdef DEBUG
					ATLPath::Append(srcManifest, _T("NToolsCommonUID.dll"));
					ATLPath::Append(dstManifest, _T("NToolsCommonUID.dll"));
#else
					ATLPath::Append(srcManifest, _T("NToolsCommonUI.dll"));
					ATLPath::Append(dstManifest, _T("NToolsCommonUI.dll"));
#endif
					CopyFile(srcManifest, dstManifest, FALSE);

					ATLPath::RemoveFileSpec(srcManifest);
					ATLPath::RemoveFileSpec(dstManifest);
					ATLPath::Append(srcManifest, _T("NToolsUpdaterResource_ko-KR.zip"));
					ATLPath::Append(dstManifest, _T("NToolsUpdaterResource_ko-KR.zip"));
					CopyFile(srcManifest, dstManifest, FALSE);

					ATLPath::RemoveFileSpec(srcManifest);
					ATLPath::RemoveFileSpec(dstManifest);
					ATLPath::Append(srcManifest, _T("gdiplus.dll"));
					ATLPath::Append(dstManifest, _T("gdiplus.dll"));
					CopyFile(srcManifest, dstManifest, FALSE);
#endif // #ifdef AGREEMENT_CHANGE

//				}

				CAtlString strText;
				strText.Format(_T("ShellExecute - %s\r\n"), tempFilePath);
				::OutputDebugString(strText);

				// ڽ ϱ ؽ Ѵ.   ̱νϽ   ʴ´.
				DeleteThisMutex();
				if (ShellExecute(NULL, NULL, tempFilePath, cmdParameter, NULL, SW_SHOW))
				{
					return;
				}
			}
		}

		BOOL IsSingleInstance(LPCTSTR guid) 
		{ 
			//return CheckInExecution::CheckMutex(_T("{}"));
			return this->CreateMutex(guid, m_hMutex);
		}
		BOOL CheckNetwork() 
		{
			int i;
			for( i = RETRY_NETWORK_CONNECT_COUNT; i > 0 ; i-- )
			{
				if ( TRUE == CheckInExecution::CheckNetworkStatus(_T("update-ntalk.ncloudbiz.com"/*"cdn.naver.com"*/), 80, 1) )
					break;

				Sleep(RETRY_NETWORK_CONNECT_SLEEP_TIME);
			}

			return (i > 0) ? TRUE : FALSE;
		}

		BOOL IsRunProgram(LPCTSTR guid) 
		{
			//  GUID
			HANDLE handle = NULL;
			BOOL bRunProgram = !(this->CreateMutex(guid, handle));
			DeleteMutex(handle);
			return bRunProgram;
		}

		BOOL IsInstalledUpdater()
		{
			TCHAR szPath[MAX_PATH] = {0, };
			return GetProgramFolder(szPath, MAX_PATH);
		}

		BOOL GetProgramFolder(TCHAR* szPath, int size)
		{
			// α׷   ; 
// 			CRegKey reg;
// 			if (ERROR_SUCCESS != reg.Open(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\NToolsUpdater"), KEY_READ))
// 			return FALSE;
// 
// 			ULONG bufSize = size;
// 			LONG err = reg.QueryStringValue(_T("DisplayIcon"), szPath, &bufSize);
// 			if (err != ERROR_SUCCESS)
// 				return FALSE;
// 			ATLPath::RemoveFileSpec(szPath);

			BOOL result = FALSE; 
			GetCurrentDirectory(size, szPath);
			result = TRUE; 
			return result;
		}

		BOOL GetProgramRootFolder(TCHAR* szPath, int size)
		{

			BOOL result = FALSE; 
			GetCurrentDirectory(size, szPath);
			result = TRUE; 
			return result;
		}

		CString GetConfigFilePath()
		{
			const TCHAR CONFIG_XML_FILENAME[] = _T("NtalkUpdater.xml");
			LPITEMIDLIST lpi;
			HRESULT hResult;
			TCHAR pszPath[MAX_PATH] = {'\0',};

			hResult = SHGetSpecialFolderLocation(NULL, CSIDL_LOCAL_APPDATA, &lpi);
			SHGetPathFromIDList(lpi, pszPath);

			CoTaskMemFree(lpi);

			_tcscat_s(pszPath, MAX_PATH, _T("\\Ntalkbiz"));
			if(_waccess(pszPath, 0) == -1)
				_wmkdir(pszPath);


			CString configFile = pszPath;
			configFile += _T("\\");
			configFile += CONFIG_XML_FILENAME;
			return configFile;
		}

		BOOL CopyOldConfigFile(CString strConfigPath)
		{
			const TCHAR CONFIG_XML_FILENAME[] = _T("NtalkUpdater.xml");
			TCHAR szPath[MAX_PATH] = {0, };
			GetProgramFolder(szPath, MAX_PATH);
			CString configFile = szPath;
			configFile += _T("\\");
			configFile += CONFIG_XML_FILENAME;

			if(_waccess(configFile, 0) == -1)
				return FALSE;

			return CopyFile(configFile, strConfigPath, FALSE);
		}

		CString GetLicenseInfoPath()
		{
			const TCHAR CONFIG_XML_FILENAME[] = _T("Ntools_license_Info.xml");
			TCHAR szPath[MAX_PATH] = {0, };
			GetProgramFolder(szPath, MAX_PATH);
			CString configFile = szPath;
			configFile += _T("\\");
			configFile += CONFIG_XML_FILENAME;
			return configFile;
		}

		BOOL CreateMutex(LPCTSTR mutexName, HANDLE& handle)
		{
			handle = ::CreateMutex( NULL, TRUE, mutexName );

			if( handle == NULL )
			{
				DWORD err = GetLastError();
				return FALSE;
			}

			if (GetLastError() == ERROR_ALREADY_EXISTS)
			{
				return FALSE;
			}

			return TRUE;
		}
		void DeleteMutex(HANDLE& handle)
		{
			if (handle)
			{
				ReleaseMutex(handle);
				CloseHandle(handle);
			}
			handle = NULL;
		}
		HANDLE ExecuteProgram( LPCTSTR path, LPCTSTR para )
		{
			SHELLEXECUTEINFO sei = { sizeof(sei) };
			sei.fMask = SEE_MASK_NOCLOSEPROCESS;
			sei.nShow = SW_SHOWNORMAL; // added 27 Nov
			sei.lpVerb = _T("open");
			sei.lpFile = path;
			sei.lpParameters = para;
			if( FALSE == ShellExecuteEx(&sei) )
				return NULL;

			return sei.hProcess;
		}
		void DeleteThisMutex()
		{
			DeleteMutex(m_hMutex);
		}

	private:
		HANDLE m_hMutex;
	};
};